# coding: utf-8

"""
    Collibra Catalog Database Registration API

    This API allows you to manage the **metadata ingestion**, **profiling**, and **classification** of databases via Edge.  It provides the following functionalities: - Query and synchronize the database and schema connections. - Register the databases to be ingested, profiled and classified. - Configure and trigger the metadata ingestion of databases. - Configure and trigger the profiling and classification of databases.   # noqa: E501

    OpenAPI spec version: 1.4.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AddDatabaseRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'database_connection_id': 'str',
        'community_id': 'str',
        'parent_system_id': 'str',
        'owner_ids': 'list[str]',
        'description': 'str'
    }

    attribute_map = {
        'database_connection_id': 'databaseConnectionId',
        'community_id': 'communityId',
        'parent_system_id': 'parentSystemId',
        'owner_ids': 'ownerIds',
        'description': 'description'
    }

    def __init__(self, database_connection_id=None, community_id=None, parent_system_id=None, owner_ids=None, description=None):  # noqa: E501
        """AddDatabaseRequest - a model defined in Swagger"""  # noqa: E501
        self._database_connection_id = None
        self._community_id = None
        self._parent_system_id = None
        self._owner_ids = None
        self._description = None
        self.discriminator = None
        self.database_connection_id = database_connection_id
        self.community_id = community_id
        self.parent_system_id = parent_system_id
        self.owner_ids = owner_ids
        if description is not None:
            self.description = description

    @property
    def database_connection_id(self):
        """Gets the database_connection_id of this AddDatabaseRequest.  # noqa: E501

        The ID of the database connection. The name of a database connection becomes the name of Database asset.   # noqa: E501

        :return: The database_connection_id of this AddDatabaseRequest.  # noqa: E501
        :rtype: str
        """
        return self._database_connection_id

    @database_connection_id.setter
    def database_connection_id(self, database_connection_id):
        """Sets the database_connection_id of this AddDatabaseRequest.

        The ID of the database connection. The name of a database connection becomes the name of Database asset.   # noqa: E501

        :param database_connection_id: The database_connection_id of this AddDatabaseRequest.  # noqa: E501
        :type: str
        """
        if database_connection_id is None:
            raise ValueError("Invalid value for `database_connection_id`, must not be `None`")  # noqa: E501

        self._database_connection_id = database_connection_id

    @property
    def community_id(self):
        """Gets the community_id of this AddDatabaseRequest.  # noqa: E501

        The ID of the parent community in which the initial domain and database asset will be created.  # noqa: E501

        :return: The community_id of this AddDatabaseRequest.  # noqa: E501
        :rtype: str
        """
        return self._community_id

    @community_id.setter
    def community_id(self, community_id):
        """Sets the community_id of this AddDatabaseRequest.

        The ID of the parent community in which the initial domain and database asset will be created.  # noqa: E501

        :param community_id: The community_id of this AddDatabaseRequest.  # noqa: E501
        :type: str
        """
        if community_id is None:
            raise ValueError("Invalid value for `community_id`, must not be `None`")  # noqa: E501

        self._community_id = community_id

    @property
    def parent_system_id(self):
        """Gets the parent_system_id of this AddDatabaseRequest.  # noqa: E501

        The ID of the parent *System* asset. After registering a database, a relation of type *Technology Asset groups / is grouped by technology Asset* is created between the System asset and the Database asset.  # noqa: E501

        :return: The parent_system_id of this AddDatabaseRequest.  # noqa: E501
        :rtype: str
        """
        return self._parent_system_id

    @parent_system_id.setter
    def parent_system_id(self, parent_system_id):
        """Sets the parent_system_id of this AddDatabaseRequest.

        The ID of the parent *System* asset. After registering a database, a relation of type *Technology Asset groups / is grouped by technology Asset* is created between the System asset and the Database asset.  # noqa: E501

        :param parent_system_id: The parent_system_id of this AddDatabaseRequest.  # noqa: E501
        :type: str
        """
        if parent_system_id is None:
            raise ValueError("Invalid value for `parent_system_id`, must not be `None`")  # noqa: E501

        self._parent_system_id = parent_system_id

    @property
    def owner_ids(self):
        """Gets the owner_ids of this AddDatabaseRequest.  # noqa: E501

        The IDs of the users that are assigned as the Owner of the automatically created domain containing the Database asset.   # noqa: E501

        :return: The owner_ids of this AddDatabaseRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._owner_ids

    @owner_ids.setter
    def owner_ids(self, owner_ids):
        """Sets the owner_ids of this AddDatabaseRequest.

        The IDs of the users that are assigned as the Owner of the automatically created domain containing the Database asset.   # noqa: E501

        :param owner_ids: The owner_ids of this AddDatabaseRequest.  # noqa: E501
        :type: list[str]
        """
        if owner_ids is None:
            raise ValueError("Invalid value for `owner_ids`, must not be `None`")  # noqa: E501

        self._owner_ids = owner_ids

    @property
    def description(self):
        """Gets the description of this AddDatabaseRequest.  # noqa: E501

        A description of the database.  # noqa: E501

        :return: The description of this AddDatabaseRequest.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this AddDatabaseRequest.

        A description of the database.  # noqa: E501

        :param description: The description of this AddDatabaseRequest.  # noqa: E501
        :type: str
        """

        self._description = description

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AddDatabaseRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AddDatabaseRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
