# coding: utf-8

"""
    Collibra Catalog Database Registration API

    This API allows you to manage the **metadata ingestion**, **profiling**, and **classification** of databases via Edge.  It provides the following functionalities: - Query and synchronize the database and schema connections. - Register the databases to be ingested, profiled and classified. - Configure and trigger the metadata ingestion of databases. - Configure and trigger the profiling and classification of databases.   # noqa: E501

    OpenAPI spec version: 1.4.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AddSchemaProfilingConfigurationRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'schema_connection_id': 'str',
        'profiling_rules': 'SchemaProfilingRules'
    }

    attribute_map = {
        'schema_connection_id': 'schemaConnectionId',
        'profiling_rules': 'profilingRules'
    }

    def __init__(self, schema_connection_id=None, profiling_rules=None):  # noqa: E501
        """AddSchemaProfilingConfigurationRequest - a model defined in Swagger"""  # noqa: E501
        self._schema_connection_id = None
        self._profiling_rules = None
        self.discriminator = None
        self.schema_connection_id = schema_connection_id
        self.profiling_rules = profiling_rules

    @property
    def schema_connection_id(self):
        """Gets the schema_connection_id of this AddSchemaProfilingConfigurationRequest.  # noqa: E501

        The ID of the schema connection.  # noqa: E501

        :return: The schema_connection_id of this AddSchemaProfilingConfigurationRequest.  # noqa: E501
        :rtype: str
        """
        return self._schema_connection_id

    @schema_connection_id.setter
    def schema_connection_id(self, schema_connection_id):
        """Sets the schema_connection_id of this AddSchemaProfilingConfigurationRequest.

        The ID of the schema connection.  # noqa: E501

        :param schema_connection_id: The schema_connection_id of this AddSchemaProfilingConfigurationRequest.  # noqa: E501
        :type: str
        """
        if schema_connection_id is None:
            raise ValueError("Invalid value for `schema_connection_id`, must not be `None`")  # noqa: E501

        self._schema_connection_id = schema_connection_id

    @property
    def profiling_rules(self):
        """Gets the profiling_rules of this AddSchemaProfilingConfigurationRequest.  # noqa: E501


        :return: The profiling_rules of this AddSchemaProfilingConfigurationRequest.  # noqa: E501
        :rtype: SchemaProfilingRules
        """
        return self._profiling_rules

    @profiling_rules.setter
    def profiling_rules(self, profiling_rules):
        """Sets the profiling_rules of this AddSchemaProfilingConfigurationRequest.


        :param profiling_rules: The profiling_rules of this AddSchemaProfilingConfigurationRequest.  # noqa: E501
        :type: SchemaProfilingRules
        """
        if profiling_rules is None:
            raise ValueError("Invalid value for `profiling_rules`, must not be `None`")  # noqa: E501

        self._profiling_rules = profiling_rules

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AddSchemaProfilingConfigurationRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AddSchemaProfilingConfigurationRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
