# coding: utf-8

"""
    Collibra Catalog Database Registration API

    This API allows you to manage the **metadata ingestion**, **profiling**, and **classification** of databases via Edge.  It provides the following functionalities: - Query and synchronize the database and schema connections. - Register the databases to be ingested, profiled and classified. - Configure and trigger the metadata ingestion of databases. - Configure and trigger the profiling and classification of databases.   # noqa: E501

    OpenAPI spec version: 1.4.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Database(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'description': 'str',
        'community_id': 'str',
        'owner_ids': 'list[str]',
        'parent_system_id': 'str',
        'database_connection_id': 'str',
        'edge_connection_id': 'str'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'description': 'description',
        'community_id': 'communityId',
        'owner_ids': 'ownerIds',
        'parent_system_id': 'parentSystemId',
        'database_connection_id': 'databaseConnectionId',
        'edge_connection_id': 'edgeConnectionId'
    }

    def __init__(self, id=None, name=None, description=None, community_id=None, owner_ids=None, parent_system_id=None, database_connection_id=None, edge_connection_id=None):  # noqa: E501
        """Database - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._description = None
        self._community_id = None
        self._owner_ids = None
        self._parent_system_id = None
        self._database_connection_id = None
        self._edge_connection_id = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if community_id is not None:
            self.community_id = community_id
        if owner_ids is not None:
            self.owner_ids = owner_ids
        if parent_system_id is not None:
            self.parent_system_id = parent_system_id
        if database_connection_id is not None:
            self.database_connection_id = database_connection_id
        if edge_connection_id is not None:
            self.edge_connection_id = edge_connection_id

    @property
    def id(self):
        """Gets the id of this Database.  # noqa: E501

        The ID of the Database asset.  # noqa: E501

        :return: The id of this Database.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Database.

        The ID of the Database asset.  # noqa: E501

        :param id: The id of this Database.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this Database.  # noqa: E501

        The name of the Database asset.  # noqa: E501

        :return: The name of this Database.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Database.

        The name of the Database asset.  # noqa: E501

        :param name: The name of this Database.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this Database.  # noqa: E501

        A description of the Database asset.  # noqa: E501

        :return: The description of this Database.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Database.

        A description of the Database asset.  # noqa: E501

        :param description: The description of this Database.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def community_id(self):
        """Gets the community_id of this Database.  # noqa: E501

        The ID of the parent community in which the initial domain and database asset are created.  # noqa: E501

        :return: The community_id of this Database.  # noqa: E501
        :rtype: str
        """
        return self._community_id

    @community_id.setter
    def community_id(self, community_id):
        """Sets the community_id of this Database.

        The ID of the parent community in which the initial domain and database asset are created.  # noqa: E501

        :param community_id: The community_id of this Database.  # noqa: E501
        :type: str
        """

        self._community_id = community_id

    @property
    def owner_ids(self):
        """Gets the owner_ids of this Database.  # noqa: E501


        :return: The owner_ids of this Database.  # noqa: E501
        :rtype: list[str]
        """
        return self._owner_ids

    @owner_ids.setter
    def owner_ids(self, owner_ids):
        """Sets the owner_ids of this Database.


        :param owner_ids: The owner_ids of this Database.  # noqa: E501
        :type: list[str]
        """

        self._owner_ids = owner_ids

    @property
    def parent_system_id(self):
        """Gets the parent_system_id of this Database.  # noqa: E501

        The ID of the parent System asset.  # noqa: E501

        :return: The parent_system_id of this Database.  # noqa: E501
        :rtype: str
        """
        return self._parent_system_id

    @parent_system_id.setter
    def parent_system_id(self, parent_system_id):
        """Sets the parent_system_id of this Database.

        The ID of the parent System asset.  # noqa: E501

        :param parent_system_id: The parent_system_id of this Database.  # noqa: E501
        :type: str
        """

        self._parent_system_id = parent_system_id

    @property
    def database_connection_id(self):
        """Gets the database_connection_id of this Database.  # noqa: E501

        The ID of the database connection linked to the Database asset.  # noqa: E501

        :return: The database_connection_id of this Database.  # noqa: E501
        :rtype: str
        """
        return self._database_connection_id

    @database_connection_id.setter
    def database_connection_id(self, database_connection_id):
        """Sets the database_connection_id of this Database.

        The ID of the database connection linked to the Database asset.  # noqa: E501

        :param database_connection_id: The database_connection_id of this Database.  # noqa: E501
        :type: str
        """

        self._database_connection_id = database_connection_id

    @property
    def edge_connection_id(self):
        """Gets the edge_connection_id of this Database.  # noqa: E501

        The ID of the Edge connection.  # noqa: E501

        :return: The edge_connection_id of this Database.  # noqa: E501
        :rtype: str
        """
        return self._edge_connection_id

    @edge_connection_id.setter
    def edge_connection_id(self, edge_connection_id):
        """Sets the edge_connection_id of this Database.

        The ID of the Edge connection.  # noqa: E501

        :param edge_connection_id: The edge_connection_id of this Database.  # noqa: E501
        :type: str
        """

        self._edge_connection_id = edge_connection_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Database, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Database):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
