# coding: utf-8

"""
    Collibra Catalog Database Registration API

    This API allows you to manage the **metadata ingestion**, **profiling**, and **classification** of databases via Edge.  It provides the following functionalities: - Query and synchronize the database and schema connections. - Register the databases to be ingested, profiled and classified. - Configure and trigger the metadata ingestion of databases. - Configure and trigger the profiling and classification of databases.   # noqa: E501

    OpenAPI spec version: 1.4.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DatabaseConnection(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'edge_connection_id': 'str',
        'database_id': 'str'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'edge_connection_id': 'edgeConnectionId',
        'database_id': 'databaseId'
    }

    def __init__(self, id=None, name=None, edge_connection_id=None, database_id=None):  # noqa: E501
        """DatabaseConnection - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._edge_connection_id = None
        self._database_id = None
        self.discriminator = None
        self.id = id
        self.name = name
        self.edge_connection_id = edge_connection_id
        if database_id is not None:
            self.database_id = database_id

    @property
    def id(self):
        """Gets the id of this DatabaseConnection.  # noqa: E501

        The ID of the database connection.  # noqa: E501

        :return: The id of this DatabaseConnection.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DatabaseConnection.

        The ID of the database connection.  # noqa: E501

        :param id: The id of this DatabaseConnection.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this DatabaseConnection.  # noqa: E501

        The exact name of a database (catalog) read from the source.  # noqa: E501

        :return: The name of this DatabaseConnection.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DatabaseConnection.

        The exact name of a database (catalog) read from the source.  # noqa: E501

        :param name: The name of this DatabaseConnection.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def edge_connection_id(self):
        """Gets the edge_connection_id of this DatabaseConnection.  # noqa: E501

        The ID of the Edge connection.  # noqa: E501

        :return: The edge_connection_id of this DatabaseConnection.  # noqa: E501
        :rtype: str
        """
        return self._edge_connection_id

    @edge_connection_id.setter
    def edge_connection_id(self, edge_connection_id):
        """Sets the edge_connection_id of this DatabaseConnection.

        The ID of the Edge connection.  # noqa: E501

        :param edge_connection_id: The edge_connection_id of this DatabaseConnection.  # noqa: E501
        :type: str
        """
        if edge_connection_id is None:
            raise ValueError("Invalid value for `edge_connection_id`, must not be `None`")  # noqa: E501

        self._edge_connection_id = edge_connection_id

    @property
    def database_id(self):
        """Gets the database_id of this DatabaseConnection.  # noqa: E501

        The ID of the Database asset linked with this database connection.  # noqa: E501

        :return: The database_id of this DatabaseConnection.  # noqa: E501
        :rtype: str
        """
        return self._database_id

    @database_id.setter
    def database_id(self, database_id):
        """Sets the database_id of this DatabaseConnection.

        The ID of the Database asset linked with this database connection.  # noqa: E501

        :param database_id: The database_id of this DatabaseConnection.  # noqa: E501
        :type: str
        """

        self._database_id = database_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DatabaseConnection, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DatabaseConnection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
