# coding: utf-8

"""
    Collibra Catalog Database Registration API

    This API allows you to manage the **metadata ingestion**, **profiling**, and **classification** of databases via Edge.  It provides the following functionalities: - Query and synchronize the database and schema connections. - Register the databases to be ingested, profiled and classified. - Configure and trigger the metadata ingestion of databases. - Configure and trigger the profiling and classification of databases.   # noqa: E501

    OpenAPI spec version: 1.4.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SchemaConnection(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'database_connection_id': 'str',
        'schema_id': 'str'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'database_connection_id': 'databaseConnectionId',
        'schema_id': 'schemaId'
    }

    def __init__(self, id=None, name=None, database_connection_id=None, schema_id=None):  # noqa: E501
        """SchemaConnection - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._database_connection_id = None
        self._schema_id = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if database_connection_id is not None:
            self.database_connection_id = database_connection_id
        if schema_id is not None:
            self.schema_id = schema_id

    @property
    def id(self):
        """Gets the id of this SchemaConnection.  # noqa: E501

        The ID of the schema connection.  # noqa: E501

        :return: The id of this SchemaConnection.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this SchemaConnection.

        The ID of the schema connection.  # noqa: E501

        :param id: The id of this SchemaConnection.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this SchemaConnection.  # noqa: E501

        The exact name of a schema read from the source.  # noqa: E501

        :return: The name of this SchemaConnection.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this SchemaConnection.

        The exact name of a schema read from the source.  # noqa: E501

        :param name: The name of this SchemaConnection.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def database_connection_id(self):
        """Gets the database_connection_id of this SchemaConnection.  # noqa: E501

        The ID of the database connection.  # noqa: E501

        :return: The database_connection_id of this SchemaConnection.  # noqa: E501
        :rtype: str
        """
        return self._database_connection_id

    @database_connection_id.setter
    def database_connection_id(self, database_connection_id):
        """Sets the database_connection_id of this SchemaConnection.

        The ID of the database connection.  # noqa: E501

        :param database_connection_id: The database_connection_id of this SchemaConnection.  # noqa: E501
        :type: str
        """

        self._database_connection_id = database_connection_id

    @property
    def schema_id(self):
        """Gets the schema_id of this SchemaConnection.  # noqa: E501

        The ID of the Schema asset linked with this schema connection.  # noqa: E501

        :return: The schema_id of this SchemaConnection.  # noqa: E501
        :rtype: str
        """
        return self._schema_id

    @schema_id.setter
    def schema_id(self, schema_id):
        """Sets the schema_id of this SchemaConnection.

        The ID of the Schema asset linked with this schema connection.  # noqa: E501

        :param schema_id: The schema_id of this SchemaConnection.  # noqa: E501
        :type: str
        """

        self._schema_id = schema_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SchemaConnection, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SchemaConnection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
